﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

//Image taken from http://commons.wikimedia.org/wiki/File:Tower_Bridge_and_City_Hall_at_dawn_panoramic_view.jpg

namespace _360Viewer
{
    public partial class MainPage : UserControl
    {

        private Directions _direction = Directions.Paused;
        private const int _speed = 2;

        private enum Directions
        {
            Left,Right,Paused
        }

        public MainPage()
        {
            InitializeComponent();
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
        }


        private void CompositionTarget_Rendering(object sender, EventArgs e) {
       
            if (_direction== Directions.Left)
            {
                if ((Canvas.GetLeft(tile1) + tile1.ActualWidth) < 0)//If tile1 fallen off the left
                {
                    Canvas.SetLeft(tile1, Canvas.GetLeft(tile2) + tile2.ActualWidth);
                }
                else if ((Canvas.GetLeft(tile2) + tile2.ActualWidth) < 0)//If tile2 fallen off the left
                {
                    Canvas.SetLeft(tile2, Canvas.GetLeft(tile1) + tile1.ActualWidth);
                }

                //Move the tiles along left
                Canvas.SetLeft(tile1, Canvas.GetLeft(tile1) - _speed);
                Canvas.SetLeft(tile2, Canvas.GetLeft(tile2) - _speed);

            } else if (_direction== Directions.Right) {

                if (Canvas.GetLeft(tile1) > Frame.ActualWidth )//If tile1 fallen off the right
                {
                    Canvas.SetLeft(tile1, Canvas.GetLeft(tile2) - tile1.ActualWidth);
                }
                else if (Canvas.GetLeft(tile2) > Frame.ActualWidth)//If tile2 fallen off the right
                {
                    Canvas.SetLeft(tile2, Canvas.GetLeft(tile1) - tile2.ActualWidth);
                }
             
                //Move the tiles along right
                Canvas.SetLeft(tile1, Canvas.GetLeft(tile1) + _speed);
                Canvas.SetLeft(tile2, Canvas.GetLeft(tile2) + _speed);   
            }
        }


        #region Controls

        private void RightButton_Click(object sender, RoutedEventArgs e)
        {
            _direction = Directions.Right;
        }

        private void PauseButton_Click(object sender, RoutedEventArgs e)
        {
            _direction = Directions.Paused;
        }

        private void LeftButton_Click(object sender, RoutedEventArgs e)
        {
            _direction = Directions.Left;
        }

        #endregion

    }
}
